/*
   FoRTh Modoki
   frtm.c ver 1.4.3
   Copyright (C) 1999-2001 Tomohide Naniwa. All rights reserved.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Last modified: Mar. 4, 2001.
*/
#define GREETING "FoRTh Modoki Ver. 1.4.3"
#define GREETING2 "Copyright (C) 1999-2001 Tomohide Naniwa\nFoRTh Modoki comes with NO WARRANTY."

#include <stdio.h>

#define MAIN
#include "frtm.h"
#include "errmes.h"

#define PROMPT "frtm> "
#define PROMPT2 "dict> "

main()
{
  static char line[LINE];

  printf("%s\n", GREETING);
  printf("%s\n", GREETING2);
  init_hash();
  error_no = E_OK;
  while(1) {
    if (eval_mode == DIC1 || eval_mode == DIC2) {
      printf("%s", PROMPT2);
    }
    else 
      printf("%s", PROMPT);
    fgets(line, LINE, stdin);

    eval(line);

    /* 顼ꥫХ꡼ */
    if (error_no == E_QUT) {
      break;
    }
    else if (error_no != E_OK) {
      printf("ERROR: %s\n", error_mess[error_no]);
      error_no = E_OK;
      reload_old_csp();
      if (eval_mode == DIC2) {
	/* ̤˴ */
	drop_dict();
      }
      eval_mode = RUN;
      memory = OFF;
      clear_stack();
      clear_rstack();
      clear_sstack();
    }
  }
}

eval(line)
     char *line;
{
  int i, j, len, quote;
  static char subst[LINE];

  i = 0; len = strlen(line);
  while(i < len) {
    j = 0;
    if (isspace(line[i])) {
      ++i; continue;
    }
    quote = 0;
    if (line[i] == '(') quote = 1;
    while(((! isspace(line[i])) || (quote == 1)) && line[i]) {
      if (line[i] == ')') {
	quote = 2;
	subst[j++] = line[i++];
      }
      else if (line[i] == '\\') {
        switch(line[i+1]) {
        case 'n':
          subst[j++] = '\n';
          i += 2;
          break;
        case 'b':
          subst[j++] = '\b';
          i += 2;
          break;
        case 't':
          subst[j++] = '\t';
          i += 2;
          break;
        case '0':
          if ((line[i+2] >= '0' && line[i+2] <= '7') &&
	      (line[i+3] >= '0' && line[i+3] <= '7')) {
            subst[j++] = (line[i+2]-'0') * 8 + (line[i+3] - '0');
	    i += 4;
	  }
          else {
            subst[j++] = line[i+1];
	    i += 2;
          }
          break;
        default:
          if (line[i+1]) {
            subst[j++] = line[i+1];
            i += 2;
          }
          else
            subst[j++] = line[i++];
          break;
        }
      }
      else
        subst[j++] = line[i++];
    }
    if (quote == 1) {
      error_no = E_UCB;
      break;
    }
    else if (quote == 2) {
      if (line[i-1] != ')') {
	error_no = E_UCB;
	break;
      }
    }
    subst[j] = 0;
    eval_word(subst);
    if (error_no != E_OK) break;
  }
}

eval_word(str)
     char *str;
{
  int val, i, sgn = 1;
  char *ostr;

  ostr = str;
  if (*str == '+') ++str;
  else if (*str == '-') {sgn = -1; ++str;}
  if (isdigit(*str)) {
    if (*str == '0' && str[1] == 'x') {
      /* 16 ʿɤ߹ */
      for(i = 2; str[i]; ++i) {
	if (! isxdigit(str[i])) break;
      }
      if (! str[i]) {
	sscanf(&(str[2]), "%x", &val);
	val *= sgn;
	switch(eval_mode) {
	case RUN:
	  push(val); EC;
	case SKIP:
	  if (memory == ON) {
	    cpush_int(val); EC;
	  }
	  return;
	case FGT:
	case DEF:
	case VAR:
	case DIC1:
	  error_no = E_IVN;
	  return;
	case DIC2:
	  /* Ͽ */
	  cpush_int(val); EC;
	  return;
	}
      }
    }
    else if (*str == '0') {
      /* 8 ʿɤ߹ */
      for(i = 1; str[i]; ++i) {
	if (str[i] < '0' || str[i] > '7') break;
      }
      if (! str[i]) {
	sscanf(str, "%o", &val);
	val *= sgn;
	switch(eval_mode) {
	case RUN:
	  push(val); EC;
	case SKIP:
	  if (memory == ON) {
	    cpush_int(val); EC;
	  }
	  return;
	case FGT:
	case DEF:
	case VAR:
	case DIC1:
	  error_no = E_IVN;
	  return;
	case DIC2:
	  /* Ͽ */
	  cpush_int(val); EC;
	  return;
	}
      }
    }
    else {
      /* 10 ʿɤ߹ */
      for(i = 1; str[i]; ++i) {
	if (! isdigit(str[i])) break;
      }
      if (! str[i]) {
	sscanf(str, "%d", &val);
	val *= sgn;
	switch(eval_mode) {
	case RUN:
	  push(val); EC;
	case SKIP:
	  if (memory == ON) {
	    cpush_int(val); EC;
	  }
	  return;
	case FGT:
	case DEF:
	case VAR:
	case DIC1:
	  error_no = E_IVN;
	  return;
	case DIC2:
	  /* Ͽ */
	  cpush_int(val); EC;
	  return;
	}
      }
    }
  }
  interp(ostr); EC;
}
